            #GIT_CMT=9e838a693f913737574e4ef2dbc6ac1ca24a3786
%define pname oracle-database-preinstall
%define dbrel 21c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 1%{dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: Oracle Database Preinstallation RPM
Name: %{name}
Version: %{version}
Release:    1.el7
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Requires(pre): /etc/redhat-release 
Requires: procps module-init-tools ethtool initscripts bind-utils nfs-utils util-linux-ng pam 
Requires: xorg-x11-utils xorg-x11-xauth smartmontools 
Requires: binutils glibc glibc-devel 
Requires: ksh libaio libgcc libstdc++ 
Requires: make sysstat openssh-clients 
Requires: psmisc net-tools unzip bc tar 

%if 0%{?el7} 
Requires: policycoreutils-python
%endif 
%if 0%{?el8} 
Requires: libnsl compat-openssl10 policycoreutils-python-utils
%endif  

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
The Oracle Database Preinstallation RPM automatically installs any additional
packages needed for installing Oracle Grid Infrastructure and Oracle Database
and configures your server operating system automatically, including setting
kernel parameters and other basic operating system requirements for install.

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; \
if [ -d %{configdir}/%{pname}-%1 ]; then \
  rm -rf %{configdir}/%{pname}-%1; \
fi;

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 chkconfig --del %{pname}-%1-firstboot; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
	chkconfig --add %{pname}-%1-firstboot; \
fi;

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;

%pre
%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%license LICENSE
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/rc.d/init.d/%{name}-firstboot
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Mon Jul 12 2021 Vasundhara Venkatasubramanian <vasundhara.venkatasubramanian@oracle.com> - 1.0-1.el7
- Spec name change for prod build

* Sat Apr 17 2021 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.el7]
 - Added LICENSE file and modified description [Orabug: 32778720]

* Wed Oct 14 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.3.el7]
 - Removed compat-libcap1,libaio-devel,libstdc++-devel and added policycoreutils-python [Orabug: 31961425]

* Mon Sep 21 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.2.el7]
 - Run grub2-mkconfig when params are already present in /etc/default/grub [Orabug: 31914464]
 - Fix for change in default kernel during reboot [Orabug: 31914479]
 - Set boot params when blscfg is enabled [Orabug: 31914502]

* Mon Jun 22 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.1.el7]
 - Initial version
